@echo off
rem ~ Author: Ruben ARNAUD
rem ~ Date: 09-2006

rem ~ Bad Arguments
if not .%2. == .. goto :usage

rem ~ Default parameters
set DirXnView=C:\Program Files\XnView
set DirAlbum=F:\Album
set DirFTP=C:\Docume~1\Ruben\Bureau\FTP
set GlobalCvtOpt=-opthuff -i
set HDCopy=Y
set HDNewName=%%
set HDQuality=80
set HDMaxW=0
set HDMaxH=0
set HDCvtOpt=
set NormalQuality=80
set NormalMaxW=0
set NormalMaxH=350
set NormalCvtOpt=
set TNPrefix=TN-
set TNQuality=80
set TNMaxW=128
set TNMaxH=128
set TNCvtOpt=-rmeta

rem ~ Read parameters
set ParamFile=%~d0%~p0%~n0.Params.txt
for /F "eol=; tokens=1,2* delims==" %%i in (%ParamFile%) do @set %%i=%%j

rem ~ DirName parameter
set DirName=%1
if not defined DirName goto :all_directories

set DirSrc=%DirAlbum%\%DirName%
set DirHigh=%DirFTP%\%DirName%\pwg_high
set DirPict=%DirFTP%\%DirName%
set DirTN=%DirFTP%\%DirName%\thumbnail

echo.
echo *** %DirSrc% ***

if not %HDCopy% == Y goto :convert_HD
echo.
echo Creating HD Pictures
if exist "%DirSrc%\*.JPG" xcopy /F /R /I /H /C /Y "%DirSrc%\*.JPG" "%DirHigh%\"
if exist "%DirSrc%\*.gif" xcopy /F /R /I /H /C /Y "%DirSrc%\*.gif" "%DirHigh%\"


rem ~ -o filename       : Output filename
rem ~ Use # to specify position of numeric enumerator
rem ~ Use % to specify source filename
rem ~ Use $ to specify source folder

rem ~ -out format       : Output format name

rem ~ -c value          : Compression number (default : 0)
rem ~ -q value          : JPEG/PNG/FPX/WIC quality (default : 100)

rem ~ -opthuff

rem ~ -resize w h      : Scale width-height
rem ~ w h can be percent (ex: -resize 100% 200%)

rem ~ -i                : Interlaced GIF / Progressive JPEG

:convert_HD
echo.
echo Convert HD Pictures
if not exist %DirHigh% mkdir %DirHigh%
set HD_CVT_OPT=-q %HDQuality% %GlobalCvtOpt% %HDCvtOpt% -rtype linear -ratio -resize %HDMaxW% %HDMaxH%
rem ~ Force Conversion for TIF
if exist %DirSrc%\*.TIF "%DirXnView%\nconvert.exe" %HD_CVT_OPT% -out jpeg -o %DirHigh%\%HDNewName%.WasTIF.JPG %DirSrc%\*.TIF
if %HDCopy% == Y goto :end_convert_HD
if exist %DirSrc%\*.JPG "%DirXnView%\nconvert.exe" %HD_CVT_OPT% -out jpeg -o %DirHigh%\%HDNewName%.JPG %DirSrc%\*.JPG
if exist %DirSrc%\*.gif "%DirXnView%\nconvert.exe" %HD_CVT_OPT% -out gif -o %DirHigh%\%HDNewName%.gif %DirSrc%\*.gif
:end_convert_HD


echo.
echo Creating Normal Pictures
set NO_CVT_OPT=-q %NormalQuality% %GlobalCvtOpt% %NormalCvtOpt% -rtype linear -ratio -resize %NormalMaxW% %NormalMaxH%
if exist %DirHigh%\*.JPG "%DirXnView%\nconvert.exe" %NO_CVT_OPT% -out jpeg -o %DirPict%\%%.JPG %DirHigh%\*.JPG
if exist %DirHigh%\*.gif "%DirXnView%\nconvert.exe" %NO_CVT_OPT% -out gif  -o %DirPict%\%%.gif %DirHigh%\*.gif


echo.
echo Creating thumbnail Pictures
if not exist %DirTN% mkdir %DirTN%
set TN_CVT_OPT=-q %TNQuality% %GlobalCvtOpt%  %TNCvtOpt% -rtype linear -ratio -resize %TNMaxW% %TNMaxH%
if exist %DirHigh%\*.JPG "%DirXnView%\nconvert.exe" %TN_CVT_OPT% -out jpeg -o %DirTN%\%TNPrefix%%%.JPG %DirHigh%\*.JPG
if exist %DirHigh%\*.gif "%DirXnView%\nconvert.exe" %TN_CVT_OPT% -out gif  -o %DirTN%\%TNPrefix%%%.gif %DirHigh%\*.gif


echo.
echo Creating index.php
if not exist "%DirAlbum%\index.php" goto :noindex
xcopy /F /R /I /D /H /C /Y "%DirAlbum%\index.php" "%DirPict%\"
xcopy /F /R /I /D /H /C /Y "%DirAlbum%\index.php" "%DirTN%\"
xcopy /F /R /I /D /H /C /Y "%DirAlbum%\index.php" "%DirHigh%\"
goto :end_index
:noindex
echo No file "%DirAlbum%\index.php" =^> no copies
goto :end_index
:end_index


goto :end

:all_directories
echo.
echo *************************************************************
echo * Apply %~n0 for all directories of %DirAlbum%
echo *************************************************************
echo.
pause
for /f "tokens=*" %%i in ('dir /B /A:D "%DirAlbum%"') do call %0 %%i


goto :end

:usage
echo Error Bad Parameter
echo Usage:
echo   - All directories: %0 
echo   - Selected Directory: %0 ^<Short Directory Name^>

:end
